// Xg[W
var Storage = function(debugLvl){
	this.debugLvl = (typeof(debugLvl) == "undefined" ? 1 : debugLvl);
}

Storage.prototype = {
	 get : function(key){
		// Error Check
		if(
				arguments.length	!= 1
			||	typeof(key)			!= 'string'
		){
			throw new ErrorException(this.debugLvl, 'Invalid parameter. => ['+ arguments.length + ' : ' + typeof(key) + ']');
		}

		infoMsg(this.debugLvl, 'Storage::get() param[' + key + ']');

		var val = widget.preferenceForKey(key);
		if(typeof(val) == 'undefined'){
			infoMsg(this.debugLvl, 'Storage::get() Key['+ key + '] is not found.');
		}

		return val;
	}

	,set : function(key, value){
		var ret = true;

		// Error Check
		if(
				arguments.length	!= 2
			||	typeof(key)			!= 'string'
			||	typeof(value)		!= 'string'
		){
			throw new ErrorException(this.debugLvl, 'Invalid parameter. => ['+ arguments.length + ' : ' + typeof(key) + ' : ' + typeof(value) + ']');
		}

		infoMsg(this.debugLvl, 'Storage::set() param[' + key + ' : ' + value + ']');

		ret = widget.setPreferenceForKey(value, key);
		if(!ret){
			throw new ErrorException(this.debugLvl, 'Storage::set() setPreferenceForKey failed.');
		}
	}

	,savePreferences : function(){
		infoMsg(this.debugLvl, 'Storage::savePreferences()');

		widget.savePreferences();
	}
}

